package netserv.apps.activestreaming.server;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.HashSet;
import java.util.Set;

import uk.co.caprica.vlcj.player.MediaPlayerFactory;
import uk.co.caprica.vlcj.player.headless.HeadlessMediaPlayer;

/**
 * Embedded VLC Player, uses libvlc for creating a headless player or a
 * streaming server.
 * 
 * @author Aman
 * 
 */
class VideoStreamer {
	private static HeadlessMediaPlayer mediaPlayer = null;
	private static String serverAddress;
	private static String serverPort;
	public static Set<String> Files = new HashSet<String>();
	public static final VideoStreamer PLAYER;

	static {
		PLAYER = new VideoStreamer();
	}

	/**
	 * A private constructor which creates a single instance of the headless
	 * player.
	 */
	private VideoStreamer() {
		MediaPlayerFactory mediaPlayerFactory = new MediaPlayerFactory();
		mediaPlayer = mediaPlayerFactory.newMediaPlayer();
	}

	public static void playMedia(String media, String file, String mux,
			String ip, String port) {
		Files.add(file);
		VideoStreamer.serverAddress = ip;
		VideoStreamer.serverPort = port;
		file = formatHttpStream(file, mux);
		mediaPlayer.playMedia(media, file);
		System.out.println("Starting streaming.. " + media + " with options "
				+ file);

		// when the streaming gets over we need to remove the file
	}

	public void closePlayer() {
		mediaPlayer.release();
	}

	private static String formatHttpStream(String file, String mux) {
		StringBuilder sb = new StringBuilder(60);
		sb.append(":sout=#standard{access=http,mux=" + mux + ",");
		sb.append("dst=");
		sb.append(serverAddress);
		sb.append(':');
		sb.append(serverPort + "/stream/" + file);
		sb.append("}");
		return sb.toString();
	}
}